// ****************************************************************************************************
// File: Boxes.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_BOXES
#define HURRICANE_BOXES

#include "hurricane/Collection.h"
#include "hurricane/Box.h"

namespace Hurricane {



// ****************************************************************************************************
// Boxes declaration
// ****************************************************************************************************

typedef GenericCollection<Box> Boxes;



// ****************************************************************************************************
// BoxLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Box> BoxLocator;



// ****************************************************************************************************
// BoxFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Box> BoxFilter;



// ****************************************************************************************************
// for_each_box declaration
// ****************************************************************************************************

#define for_each_box(box, boxes)\
/*******************************/\
{\
    BoxLocator _locator = boxes.getLocator();\
    while (_locator.isValid()) {\
        Box box = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_BOXES

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
