// ****************************************************************************************************
// File: Components.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_COMPONENTS
#define HURRICANE_COMPONENTS

#include "hurricane/Collection.h"

namespace Hurricane {

class Component;



// ****************************************************************************************************
// Components declaration
// ****************************************************************************************************

typedef GenericCollection<Component*> Components;



// ****************************************************************************************************
// ComponentLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Component*> ComponentLocator;



// ****************************************************************************************************
// ComponentFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Component*> ComponentFilter;



// ****************************************************************************************************
// for_each_component declaration
// ****************************************************************************************************

#define for_each_component(component, components)\
/************************************************/\
{\
    ComponentLocator _locator = components.getLocator();\
    while (_locator.isValid()) {\
        Component* component = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_COMPONENTS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
