// ****************************************************************************************************
// File: Gos.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_GOS
#define HURRICANE_GOS

#include "hurricane/Collection.h"

namespace Hurricane {

class Go;



// ****************************************************************************************************
// Gos declaration
// ****************************************************************************************************

typedef GenericCollection<Go*> Gos;



// ****************************************************************************************************
// GoLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Go*> GoLocator;



// ****************************************************************************************************
// GoFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Go*> GoFilter;



// ****************************************************************************************************
// for_each_go declaration
// ****************************************************************************************************

#define for_each_go(go, gos)\
/***************************/\
{\
    GoLocator _locator = gos.getLocator();\
    while (_locator.isValid()) {\
        Go* go = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_GOS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
