// ****************************************************************************************************
// File: Hooks.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_HOOKS
#define HURRICANE_HOOKS

#include "hurricane/Collection.h"

namespace Hurricane {

class Hook;



// ****************************************************************************************************
// Hooks declaration
// ****************************************************************************************************

typedef GenericCollection<Hook*> Hooks;



// ****************************************************************************************************
// HookLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Hook*> HookLocator;



// ****************************************************************************************************
// HookFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Hook*> HookFilter;



// ****************************************************************************************************
// for_each_hook declaration
// ****************************************************************************************************

#define for_each_hook(hook, hooks)\
/*********************************/\
{\
    HookLocator _locator = hooks.getLocator();\
    while (_locator.isValid()) {\
        Hook* hook = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_HOOKS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
