// ****************************************************************************************************
// File: Layers.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_LAYERS
#define HURRICANE_LAYERS

#include "hurricane/Collection.h"

namespace Hurricane {

class Layer;



// ****************************************************************************************************
// Layers declaration
// ****************************************************************************************************

typedef GenericCollection<Layer*> Layers;



// ****************************************************************************************************
// LayerLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Layer*> LayerLocator;



// ****************************************************************************************************
// LayerFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Layer*> LayerFilter;



// ****************************************************************************************************
// for_each_layer declaration
// ****************************************************************************************************

#define for_each_layer(layer, layers)\
/************************************/\
{\
    LayerLocator _locator = layers.getLocator();\
    while (_locator.isValid()) {\
        Layer* layer = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_LAYERS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
