// ****************************************************************************************************
// File: Markers.h
// Authors: R. Escassut
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************

#ifndef HURRICANE_MARKERS
#define HURRICANE_MARKERS

#include "hurricane/Collection.h"

namespace Hurricane {

class Marker;



// ****************************************************************************************************
// Markers declaration
// ****************************************************************************************************

typedef GenericCollection<Marker*> Markers;



// ****************************************************************************************************
// MarkerLocator declaration
// ****************************************************************************************************

typedef GenericLocator<Marker*> MarkerLocator;



// ****************************************************************************************************
// MarkerFilter declaration
// ****************************************************************************************************

typedef GenericFilter<Marker*> MarkerFilter;



// ****************************************************************************************************
// for_each_marker declaration
// ****************************************************************************************************

#define for_each_marker(marker, markers)\
/***************************************/\
{\
    MarkerLocator _locator = markers.getLocator();\
    while (_locator.isValid()) {\
        Marker* marker = _locator.getElement();\
        _locator.progress();



} // End of Hurricane namespace.

#endif // HURRICANE_MARKERS

// ****************************************************************************************************
// Copyright (c) BULL S.A. 2000-2004, All Rights Reserved
// ****************************************************************************************************
